Binding (JavaFX 13)

Module javafx.base
Package javafx.beans.binding

## Interface Binding<T>

- Type Parameters:
    `T` - the type of the wrapped value
  All Superinterfaces:
    `Observable`, `ObservableValue<T>`
  All Known Subinterfaces:
    `NumberBinding`
  All Known Implementing Classes:
    `BooleanBinding`, `DoubleBinding`, `FloatBinding`, `IntegerBinding`, `ListBinding`, `LongBinding`, `MapBinding`, `ObjectBinding`, `SetBinding`, `StringBinding`

      public interface Binding<T>
      extends ObservableValue<T>

  A `Binding` calculates a value that depends on one or more sources. The sources are usually called the dependency of a binding. A binding observes its dependencies for changes and updates its value automatically.

  While a dependency of a binding can be anything, it is almost always an implementation of `ObservableValue`. `Binding` implements `ObservableValue` allowing to use it in another binding. With that one can assemble very complex bindings from simple bindings.

  All bindings in the JavaFX runtime are calculated lazily. That means, if a dependency changes, the result of a binding is not immediately recalculated, but it is marked as invalid. Next time the value of an invalid binding is requested, it is recalculated.

  It is recommended to use one of the base classes defined in this package (e.g. `DoubleBinding`) to define a custom binding, because these classes already provide most of the needed functionality. See `DoubleBinding` for an example.

  Since:
    JavaFX 2.0
  See Also:
    `DoubleBinding`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `dispose()` | Signals to the `Binding` that it will not be used anymore and any references can be removed.
    `ObservableList<?>` | `getDependencies()` | Returns the dependencies of a binding in an unmodifiable `ObservableList`.
    `void` | `invalidate()` | Mark a binding as invalid.
    `boolean` | `isValid()` | Checks if a binding is valid.

    - ### Methods inherited from interface javafx.beans.Observable

      `addListener, removeListener`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `addListener, getValue, removeListener`

- - ### Method Detail

    - #### isValid

          boolean isValid()

      Checks if a binding is valid.
      Returns:
        `true` if the `Binding` is valid, `false` otherwise

    - #### invalidate

          void invalidate()

      Mark a binding as invalid. This forces the recalculation of the value of the `Binding` next time it is request.

    - #### getDependencies

          ObservableList<?> getDependencies()

      Returns the dependencies of a binding in an unmodifiable `ObservableList`. The implementation is optional. The main purpose of this method is to support developers during development. It allows to explore and monitor dependencies of a binding during runtime.

      Because this method should not be used in production code, it is recommended to implement this functionality as sparse as possible. For example if the dependencies do not change, each call can generate a new `ObservableList`, avoiding the necessity to store the result.

      Returns:
        an unmodifiable ObservableList of the dependencies

    - #### dispose

          void dispose()

      Signals to the `Binding` that it will not be used anymore and any references can be removed. A call of this method usually results in the binding stopping to observe its dependencies by unregistering its listener(s). The implementation is optional.

      All bindings in our implementation use instances of `WeakInvalidationListener`, which means usually a binding does not need to be disposed. But if you plan to use your application in environments that do not support `WeakReferences` you have to dispose unused `Bindings` to avoid memory leaks.